CREATE FUNCTION dbo.fnLastDayOfMonth (@mydate datetime)
RETURNS datetime
AS
BEGIN
-- Declare variables to hold the various date components
  DECLARE @yy int
  DECLARE @mm int
  DECLARE @dd int
  DECLARE @tempdate datetime
  DECLARE @foo varchar(10)

-- Store the date components
  SET @yy = DATEPART(yy, @mydate)
  SET @mm = DATEPART(mm, @mydate)
  SET @dd = DATEPART(dd, @mydate)

-- If the month is December, then set the month to January
-- and the year to year + 1,  otherwise increment month by 1
  IF @mm = 12 
    BEGIN
      SET @mm = 1
      SET @yy = @yy + 1
    END
  ELSE
    BEGIN
      SET @mm = @mm + 1
    END

--Set the day of the temporary string to the date with the day
--set to the first day of the following month.  Then convert the
--temporary string to a real date.  Then subtract one day from
--the date and return that value.
  SELECT @foo = CONVERT(varchar(2), @mm) + '/01/' + CONVERT(varchar(4), @yy)
  SET @tempdate = CONVERT(datetime, @foo)
  SET @tempdate = DATEADD(dd, -1, @tempdate)
  
  RETURN @tempdate
END

select dbo.fnlastdayofmonth('12/12/99')
select dbo.fnlastdayofmonth('02/02/99')
select dbo.fnlastdayofmonth('02/02/2000')